【数据结构-堆】2233. K 次增加后的最大乘积

给你一个非负整数数组 nums 和一个整数 k 。每次操作,你可以选择 nums 中 任一 元素并将它 增加 1 。

请你返回 至多 k 次操作后,能得到的 nums的 最大乘积 。由于答案可能很大,请你将答案对 109 + 7 取余后返回。

示例 1:

输入:nums = 0,4, k = 5

输出:20

解释:将第一个数增加 5 次。

得到 nums = 5, 4 ,乘积为 5 * 4 = 20 。

可以证明 20 是能得到的最大乘积,所以我们返回 20 。

存在其他增加 nums 的方法,也能得到最大乘积。

示例 2:

输入:nums = 6,3,3,2, k = 2

输出:216

解释:将第二个数增加 1 次,将第四个数增加 1 次。

得到 nums = 6, 4, 3, 3 ,乘积为 6 * 4 * 3 * 3 = 216 。

可以证明 216 是能得到的最大乘积,所以我们返回 216 。

存在其他增加 nums 的方法,也能得到最大乘积。

cpp 复制代码
class Solution {
public:
    int maximumProduct(vector<int>& nums, int k) {
        int MOD = 1e9 + 7;
        priority_queue<int, vector<int>, greater<int>> q(nums.begin(), nums.end());
        for(int i = 0; i < k; i++){
            int a = q.top();
            q.pop();
            a++;
            q.push(a);
        }
        
        int ans = 1;
        while(!q.empty()){
            ans = (long long)ans * q.top() % MOD;
            q.pop();
        }
        return ans;
    }
};

这道题我们要找进行k次操作后的最大乘积是多少,那么我们结合贪心的思路,我们可以知道在和一样的情况下,所有的元素越平均,最后乘积会越大。

那么也就是说我们每次进行+1操作,要对最小的元素操作,我们就可以使用小根堆来找出每一轮最小的元素,然后进行操作。

然后我们用一个变量ans记录乘积的值,将q的所有元素进行相乘记录到ans中,最后返回ans即可。

相关推荐
weixin_307779132 小时前
C++代码实现MATLAB中的dlarray函数功能
开发语言·c++·算法·matlab
hetao17338377 小时前
2026-10-03~04 hetao1733837 的刷题记录
c++·算法
Zootopia6267 小时前
飞行力学知识梳理1|飞行性能与稳定性
人工智能·python·算法·机器学习·无人机·学习方法·信息与通信
longlongzihan8 小时前
从LeetCode 70. 爬楼梯看动态规划:如何精准推导状态转移方程?
c++·算法·leetcode·动态规划
2601_960356389 小时前
2027校招采购岗解析:数学基础如何迁移到需求预测、成本与供应商分析
人工智能·算法
h_a_o777oah9 小时前
【树论】树链剖分:将树形结构转化为线性结构以处理树上路径问题(洛谷 P3384 附C++代码模板)
数据结构·算法·线段树·acm·树链剖分·树论·重链剖分
HEJOO99 小时前
指针的算术运算详解
java·数据结构·算法
Coder-magician9 小时前
《代码随想录》刷题打卡day47:并查集-part01
数据结构·算法·图论
垆边人似月.9 小时前
VLAN 资源池(100~200 分档)
数据结构·算法
潼心1412o10 小时前
C++初阶(长期更新)第6讲:类和对象(下)
开发语言·c++·算法